'use strict';

require('../../utils/click/isClickableInput.js');
require('../../utils/dataTransfer/Clipboard.js');
require('../eventMap.js');
require('./click.js');
require('./cut.js');
require('./keydown.js');
require('./keypress.js');
require('./keyup.js');
var registry = require('./registry.js');
require('@testing-library/dom');
var input = require('../../utils/edit/input.js');
var isEditable = require('../../utils/edit/isEditable.js');
require('@testing-library/dom/dist/helpers.js');
require('../../utils/keyDef/readNextDescriptor.js');
require('../../utils/misc/level.js');
require('../../options.js');

registry.behavior.paste = (event, target, config)=>{
    if (isEditable.isEditable(target)) {
        return ()=>{
            const insertData = event.clipboardData?.getData('text');
            if (insertData) {
                input.input(config, target, insertData, 'insertFromPaste');
            }
        };
    }
};
